<?php

namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class RelInsumosEquipFactory {
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function updateRelacaoInsumos($param) {
        
        $sql = "UPDATE FCM_RELINSUMOSEQUIP
                   SET QTMEDIDA = :QTMEDIDA,
                       DTULTATU = SYSDATE
                 WHERE NREQUIPAMENTO = :NREQUIPAMENTO
                   AND NRINSUMO = :NRINSUMO
                   AND NRTIPOMANUTENCAO = :NRTIPOMANUTENCAO
                   AND NRCATEGORIAMANUT = :NRCATEGORIAMANUT";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
    
    public function insertRelacaoInsumos($param) {
        
        $sql = "INSERT INTO FCM_RELINSUMOSEQUIP (NRRELINSUMOSEQUIP, NREQUIPAMENTO, NRINSUMO, NRTIPOMANUTENCAO,
                                    QTMEDIDA, NRORG, IDATIVO, DTINCLUSAO, NRCATEGORIAMANUT)
              VALUES (:NRRELINSUMOSEQUIP, :NREQUIPAMENTO, :NRINSUMO, :NRTIPOMANUTENCAO,
                        :QTMEDIDA, :NRORG, 'S', SYSDATE, :NRCATEGORIAMANUT)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($param);
    }
}

?>