/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8340_CMPSTPO.sql

Descrio:
Busca e insere os impostos que incidem em um determiando produto da AF.

Criao:
27/04/2000 Yoris L. de Souza
*/

CREATE OR REPLACE PROCEDURE IMPOSTO_INCIDE_PRODAF
                     (P_CDFILDEST   IN ITEMAUTF.CDFILDEST%TYPE,
                      P_CDFILLANC   IN ITEMAUTF.CDFILLANC%TYPE,
                      P_NRAUTOFORN  IN ITEMAUTF.NRAUTOFORN%TYPE,
                      P_CDPRODUTO   IN ITEMAUTF.CDPRODUTO%TYPE,
                      P_CDMARCA     IN ITEMAUTF.CDMARCA%TYPE,
                      P_DTPROGENTAF IN ITEMAUTF.DTPROGENTAF%TYPE)

IS
   V_TIPOOPER   VARCHAR2(02);
   V_CDEMPRESA  INCIDENCIA.CDEMPRESA%TYPE;
   V_CDINSCESTA INCIDENCIA.CDINSCESTA%TYPE;
   V_CDARVPROD  PRODUTO.CDARVPROD%TYPE;

BEGIN
 SELECT
   MAX(AUTOFORNE.CDEMPRESA)
   INTO
     V_CDEMPRESA
 FROM AUTOFORNE
 WHERE
   AUTOFORNE.CDFILDEST  = P_CDFILDEST  AND
   AUTOFORNE.CDFILLANC  = P_CDFILLANC  AND
   AUTOFORNE.NRAUTOFORN = P_NRAUTOFORN;

 SELECT MAX(CDINSCESTA) INTO V_CDINSCESTA
 FROM FILIAL
 WHERE
   CDFILIAL  = P_CDFILDEST AND
   CDEMPRESA = V_CDEMPRESA;

 SELECT
    NVL(MAX(PARCMPSUP.CDTIPOOPER), '01') INTO V_TIPOOPER
 FROM
    PARCMPSUP,
    FILIAL
 WHERE
    (FILIAL.CDFILIAL    = P_CDFILDEST) AND
    (PARCMPSUP.CDFILIAL = NVL(FILIAL.CDFILCENTCMP, FILIAL.CDFILIAL));
    
 FOR C_IMPOSTO IN (SELECT DISTINCT (CDIMPOSTO) AS CDIMPOSTO FROM INCIDENCIA) LOOP


    SELECT MAX(PRODUTO.CDARVPROD) INTO V_CDARVPROD
       FROM INCIDENCIA, PRODUTO, PRODUTO P
       WHERE (INCIDENCIA.IDENTRSAIDIN = 'E') AND
             (INCIDENCIA.CDEMPRESA    = V_CDEMPRESA) AND
             (INCIDENCIA.CDTIPOOPER   = V_TIPOOPER) AND
             (INCIDENCIA.CDIMPOSTO    = C_IMPOSTO.CDIMPOSTO) AND
             (INCIDENCIA.CDINSCESTA   = RTRIM(V_CDINSCESTA)) AND
             (INCIDENCIA.CDPRODUTO    = PRODUTO.CDPRODUTO)   AND
             (P.CDPRODUTO = P_CDPRODUTO) AND
             (INSTR(P.CDARVPROD,RTRIM(PRODUTO.CDARVPROD)) = 1 OR PRODUTO.CDARVPROD IS NULL);

    IF NOT (V_CDARVPROD IS NULL) THEN
       FOR C_INCIDENCIA IN (
          SELECT INCIDENCIA.CDIMPOSTO, CDFISCAL
             FROM INCIDENCIA, PRODUTO
             WHERE (INCIDENCIA.IDENTRSAIDIN = 'E') AND
                   (INCIDENCIA.CDEMPRESA    = V_CDEMPRESA) AND
                   (INCIDENCIA.CDTIPOOPER   = V_TIPOOPER) AND
                   (INCIDENCIA.CDIMPOSTO    = C_IMPOSTO.CDIMPOSTO) AND
                   (INCIDENCIA.CDINSCESTA   = RTRIM(V_CDINSCESTA)) AND
                   (INCIDENCIA.CDPRODUTO    = PRODUTO.CDPRODUTO)   AND
                   (PRODUTO.CDARVPROD       = V_CDARVPROD)) LOOP

            INSERT INTO IMPITMAF
           (CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, CDMARCA,
            DTPROGENTAF, CDIMPOSTO, VRALIQITMAF, VRIMPITMAF, CDFISCITMAF,VRADIMPAF)
            VALUES
           (P_CDFILDEST, P_CDFILLANC, P_NRAUTOFORN, P_CDPRODUTO, P_CDMARCA,
            P_DTPROGENTAF, C_INCIDENCIA.CDIMPOSTO,0,0,C_INCIDENCIA.CDFISCAL,0);
       END LOOP;
    ELSIF (V_CDARVPROD IS NULL) THEN
       FOR C_INCIDNULL IN (
          SELECT INCIDENCIA.CDIMPOSTO, CDFISCAL
             FROM INCIDENCIA
             WHERE (INCIDENCIA.IDENTRSAIDIN = 'E') AND
                   (INCIDENCIA.CDEMPRESA = V_CDEMPRESA) AND
                   (INCIDENCIA.CDTIPOOPER = V_TIPOOPER) AND
                   (INCIDENCIA.CDIMPOSTO = C_IMPOSTO.CDIMPOSTO) AND
                   (INCIDENCIA.CDINSCESTA = RTRIM(V_CDINSCESTA)) AND
                   (INCIDENCIA.CDPRODUTO IS NULL)) LOOP

            INSERT INTO IMPITMAF
           (CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, CDMARCA,
            DTPROGENTAF, CDIMPOSTO, VRALIQITMAF, VRIMPITMAF, CDFISCITMAF,VRADIMPAF)
            VALUES
           (P_CDFILDEST, P_CDFILLANC, P_NRAUTOFORN, P_CDPRODUTO, P_CDMARCA,
            P_DTPROGENTAF, C_INCIDNULL.CDIMPOSTO,0,0,C_INCIDNULL.CDFISCAL,0);

       END LOOP;
    END IF;
 END LOOP;
END;
/

